-- generated with romgen v3.0 by MikeJ
library ieee;
  use ieee.std_logic_1164.all;
  use ieee.std_logic_unsigned.all;
  use ieee.numeric_std.all;

library UNISIM;
  use UNISIM.Vcomponents.all;

entity rom_cartridge is
  port (
    CLK         : in    std_logic;
    ADDR        : in    std_logic_vector(12 downto 0);
    DATA        : out   std_logic_vector(7 downto 0)
    );
end;

architecture RTL of rom_cartridge is

  function romgen_str2bv (str : string) return bit_vector is
    variable result : bit_vector (str'length*4-1 downto 0);
  begin
    for i in 0 to str'length-1 loop
      case str(str'high-i) is
        when '0'       => result(i*4+3 downto i*4) := x"0";
        when '1'       => result(i*4+3 downto i*4) := x"1";
        when '2'       => result(i*4+3 downto i*4) := x"2";
        when '3'       => result(i*4+3 downto i*4) := x"3";
        when '4'       => result(i*4+3 downto i*4) := x"4";
        when '5'       => result(i*4+3 downto i*4) := x"5";
        when '6'       => result(i*4+3 downto i*4) := x"6";
        when '7'       => result(i*4+3 downto i*4) := x"7";
        when '8'       => result(i*4+3 downto i*4) := x"8";
        when '9'       => result(i*4+3 downto i*4) := x"9";
        when 'A'       => result(i*4+3 downto i*4) := x"A";
        when 'B'       => result(i*4+3 downto i*4) := x"B";
        when 'C'       => result(i*4+3 downto i*4) := x"C";
        when 'D'       => result(i*4+3 downto i*4) := x"D";
        when 'E'       => result(i*4+3 downto i*4) := x"E";
        when 'F'       => result(i*4+3 downto i*4) := x"F";
        when others    => null;
      end case;
    end loop;
    return result;
  end romgen_str2bv;

  attribute INIT_00 : string;
  attribute INIT_01 : string;
  attribute INIT_02 : string;
  attribute INIT_03 : string;
  attribute INIT_04 : string;
  attribute INIT_05 : string;
  attribute INIT_06 : string;
  attribute INIT_07 : string;
  attribute INIT_08 : string;
  attribute INIT_09 : string;
  attribute INIT_0A : string;
  attribute INIT_0B : string;
  attribute INIT_0C : string;
  attribute INIT_0D : string;
  attribute INIT_0E : string;
  attribute INIT_0F : string;
  attribute INIT_10 : string;
  attribute INIT_11 : string;
  attribute INIT_12 : string;
  attribute INIT_13 : string;
  attribute INIT_14 : string;
  attribute INIT_15 : string;
  attribute INIT_16 : string;
  attribute INIT_17 : string;
  attribute INIT_18 : string;
  attribute INIT_19 : string;
  attribute INIT_1A : string;
  attribute INIT_1B : string;
  attribute INIT_1C : string;
  attribute INIT_1D : string;
  attribute INIT_1E : string;
  attribute INIT_1F : string;
  attribute INIT_20 : string;
  attribute INIT_21 : string;
  attribute INIT_22 : string;
  attribute INIT_23 : string;
  attribute INIT_24 : string;
  attribute INIT_25 : string;
  attribute INIT_26 : string;
  attribute INIT_27 : string;
  attribute INIT_28 : string;
  attribute INIT_29 : string;
  attribute INIT_2A : string;
  attribute INIT_2B : string;
  attribute INIT_2C : string;
  attribute INIT_2D : string;
  attribute INIT_2E : string;
  attribute INIT_2F : string;
  attribute INIT_30 : string;
  attribute INIT_31 : string;
  attribute INIT_32 : string;
  attribute INIT_33 : string;
  attribute INIT_34 : string;
  attribute INIT_35 : string;
  attribute INIT_36 : string;
  attribute INIT_37 : string;
  attribute INIT_38 : string;
  attribute INIT_39 : string;
  attribute INIT_3A : string;
  attribute INIT_3B : string;
  attribute INIT_3C : string;
  attribute INIT_3D : string;
  attribute INIT_3E : string;
  attribute INIT_3F : string;

  component RAMB16_S2
    --pragma translate_off
    generic (
      INIT_00 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_01 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_02 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_03 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_04 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_05 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_06 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_07 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_08 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_09 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0A : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0B : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0C : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0D : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0E : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0F : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_10 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_11 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_12 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_13 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_14 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_15 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_16 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_17 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_18 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_19 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1A : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1B : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1C : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1D : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1E : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1F : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_20 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_21 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_22 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_23 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_24 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_25 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_26 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_27 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_28 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_29 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2A : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2B : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2C : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2D : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2E : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2F : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_30 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_31 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_32 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_33 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_34 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_35 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_36 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_37 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_38 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_39 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3A : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3B : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3C : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3D : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3E : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3F : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000"
      );
    --pragma translate_on
    port (
      DO    : out std_logic_vector (1 downto 0);
      ADDR  : in  std_logic_vector (12 downto 0);
      CLK   : in  std_logic;
      DI    : in  std_logic_vector (1 downto 0);
      EN    : in  std_logic;
      SSR   : in  std_logic;
      WE    : in  std_logic 
      );
  end component;

  signal rom_addr : std_logic_vector(12 downto 0);

begin

  p_addr : process(ADDR)
  begin
     rom_addr <= (others => '0');
     rom_addr(12 downto 0) <= ADDR;
  end process;

  rom0 : if true generate
    attribute INIT_00 of inst : label is "A5DD5F8A15085329309E2671EB9239E2485EE7B121425C6D06CC650C034C51F3";
    attribute INIT_01 of inst : label is "F5C192489AD95380F1D2298821622C9ECCD8DBD702E185C70B6A6F20A2025957";
    attribute INIT_02 of inst : label is "23D6FC9EAE98AC64B2FCBAC7A3220A1ACACCB220A5DD5F8A3ACFA3220A236236";
    attribute INIT_03 of inst : label is "208F8FFB8B1BC633AFAF2C7989A012264597757E28B7546D6A5DD5F8A156420B";
    attribute INIT_04 of inst : label is "2F2EB388A23C8E55E97757E2814E288C27899B5A97757E28F232FA20F3A1A2A3";
    attribute INIT_05 of inst : label is "F5C0B861730AE26F209602F2BBCBACA3208D2622F676977513A8F5923F6A03EA";
    attribute INIT_06 of inst : label is "A2A78AAAB2CC82B0A297757E2836F5C1AE369226B65824A6E0858AE328B32E36";
    attribute INIT_07 of inst : label is "28A596A0C86CBAC2220BB2F0042FA2A8BCB8A5DD44EA051F24D832083008F316";
    attribute INIT_08 of inst : label is "A088F6BCABB8BCB1D61A2B5697757E28159F2279C5344B9EC499445B5297757E";
    attribute INIT_09 of inst : label is "C5DD500C8B46F8166D89AF8E6C4CA23A9239EC0F7E653ECC74A93F260A5DD44E";
    attribute INIT_0A of inst : label is "E532EE3223FCD7C9BAEAA26B1E177FF09FF778977513A87F1D37DA13DC74FF68";
    attribute INIT_0B of inst : label is "F15DD1DC0F8DF9A5DD5F8A0DAC8CACFB31897D65DD44EA2DF34C0BC493EE5FCE";
    attribute INIT_0C of inst : label is "0F8DF9A5DD5F8A0D938C23ECC62C748DB4058340580320B37C8EAB6CAE8D4B7F";
    attribute INIT_0D of inst : label is "D8DCC8BCAE60B2E168468180E33828A8CAEB4ACAA3524182CBA320C82BE64DDC";
    attribute INIT_0E of inst : label is "BBB59C9A977513A860C6F2ABF2BF21EFAEED4736E8C4100428F8BA96B29E1441";
    attribute INIT_0F of inst : label is "1A94446D9B00BCD45111A94446D9830BCD4EFFC3E33254808EB5A888822229BE";
    attribute INIT_10 of inst : label is "3E33E7BA2E7F168CC82A1AB930B320936F2A300325A6D0206720190026040511";
    attribute INIT_11 of inst : label is "7757E283687C8D4BA8CCE2C1A18E83216B4A50CB81430C13206BF224823D2770";
    attribute INIT_12 of inst : label is "59F20886AE97757E28F27F296870D6082BCB08CB82AC9E5B3130A3CC824E32F9";
    attribute INIT_13 of inst : label is "F25E32F97757E283684D4A8CCE2C1A1AEEF2B31D66AF9EBC9DC0F8CF9E28B9FC";
    attribute INIT_14 of inst : label is "5F097757E28E4C893027BBDCDA052EF70671C7D4F50BE863E37C1B1800A1A262";
    attribute INIT_15 of inst : label is "89C2752927499454214C665DD5F8A2984E885F097757E283685E885F03686E88";
    attribute INIT_16 of inst : label is "C273E703E37D097757E283686E88D4831A128E3B9DC0F833E37D097757E28E4C";
    attribute INIT_17 of inst : label is "2CA52CA52C9CF9C0F8DF425DD5F8A0DA10DE88D4A3FB3F032B3B0DC82FABAE22";
    attribute INIT_18 of inst : label is "727703E3E374328914E28A5DD5F8A19A61382352840C2320D328CB228A2AD8A5";
    attribute INIT_19 of inst : label is "E5DD5F8A0DA1CE863352027703E3E374F28918DF97757E2836873A9BCCD480F4";
    attribute INIT_1A of inst : label is "2893C2A85F0AA134832ADCAB30A32ADCAB38BC0C9549838637FECE6CBEE25637";
    attribute INIT_1B of inst : label is "12142336768B3E88D30C1033440F262E8EC89E70326283B6281E9003F2122A48";
    attribute INIT_1C of inst : label is "20234A02028F2BA73F26A628085B036781036B9EC4B9E1A2E48E78920C0DAE7B";
    attribute INIT_1D of inst : label is "892E78834C2850CED224232C7330C573B6ECCDE338D3C4C1354E8D4434C20C88";
    attribute INIT_1E of inst : label is "A0ECB5DB8918EE6F24DCD775575C0BF19018F9EC4936E6F36367EF49DA2E29E7";
    attribute INIT_1F of inst : label is "A2CFACA5DD5F8A0DA28265E0999754B82665D5EADADC2F7294301F17CA5DD44E";
    attribute INIT_20 of inst : label is "4BA721A2278FDC0850C3668B3E7297757E28368A099DA621A2278EDC085000D9";
    attribute INIT_21 of inst : label is "6A28659E78676BE2B252D30D2B0B166DCF10A403EA8C8AB9AC3CBC92CADA0A85";
    attribute INIT_22 of inst : label is "8D4A08C6C4BBC59770B3E837A23E833E87043086878DC69E8B3E97757E283693";
    attribute INIT_23 of inst : label is "30D90D88AE80C211F20A3309023F7C060D51521468A5A21C2A632B59A3204D56";
    attribute INIT_24 of inst : label is "D9CF09CFE889F113E8D8BEB4CABA35EA55F6CD0F20E3370627088EA98480CC03";
    attribute INIT_25 of inst : label is "C0C2FA06070307E00BCD0FE028A033418A0FC8BF00F4EDA807EF8F864060A085";
    attribute INIT_26 of inst : label is "036004CCF6F87E5B0B9AF83EC0974C976AF3AB8421CBAEE88E02E145E7E2C1C1";
    attribute INIT_27 of inst : label is "BE030500044C5C68149B15C010000058650C06C61000988EEED988EEDD000000";
    attribute INIT_28 of inst : label is "0303020202010101000000000FE23806127542418D8000C5000E7D0541C06055";
    attribute INIT_29 of inst : label is "AAA9555557F3F3F2A2A2A1515153C3C3C2828281414142C2C2C1C1C1C1818183";
    attribute INIT_2A of inst : label is "3801400131810001380140013EDF35E457F017B5ADB31A413BC9F713FFFFFEAA";
    attribute INIT_2B of inst : label is "8888888888888888BBBBBBBBBBBBBBBB80480404042B50C30C30C30C01810001";
    attribute INIT_2C of inst : label is "555555555111111111DDDDDDDDD9999999999555555555111111111DDDDDDDDD";
    attribute INIT_2D of inst : label is "DE79CC0D0C30C30C30C0430C30C30C302EFFCCDDEEFFCCD9AABB8899AABB8895";
    attribute INIT_2E of inst : label is "0D5DC7DB6E31CC0DAF09FF8D30CC0D7C4BEBECF7CC0D9FC0D7AD70CC0D8EC1C7";
    attribute INIT_2F of inst : label is "FFAFF0CC0D8E43FB2EF6CC0D1C0FC3AFFFCC0D7CC9F79F3ACC0DAC44C38CF5CC";
    attribute INIT_30 of inst : label is "CC0D5CCCC38C7FCC0DFE08E7EDFECC0D5D0BD78F30CC0DDCC4EB1C7DCC0DBD4F";
    attribute INIT_31 of inst : label is "43EBEEFFCC0D1DC0F7AF70CC0D8CC9E75C71CC0D3FC5C3AC35CC0DDF0BDF6CFA";
    attribute INIT_32 of inst : label is "F7CC0DFEC1D71F3ACC0DAE44C38EFDCC0DDFCFDB6E39CC0DAF01DF8D30CC0DFE";
    attribute INIT_33 of inst : label is "DD03F78F30CC0D5EC4EB9E75CC0D3F47DFADF0CC0D8C4BFB2CF6CC0D9C07C3AD";
    attribute INIT_34 of inst : label is "FD75FF01BDCDC3AC3DCC0D5F03FF6EFACC0DDECCC38E77CC0D7E08C7EFFECC0D";
    attribute INIT_35 of inst : label is "01FEBAD75EBAFF016C73D34CF1DB014CB2F3CCB2D3011DB9CF3E76C701FD75FF";
    attribute INIT_36 of inst : label is "F3CEF9FB015FFFD75FFFD7014CF1DB6C73D301CCB2D34CB2F3013D36C71DB4CF";
    attribute INIT_37 of inst : label is "D301CEF9FBEE7BF3015EBAFFFEBAD7019FBCEFBF3EE701CCB2D34CB2F301EE7B";
    attribute INIT_38 of inst : label is "B2F3CCB2D3019DB1EFBC76E7017F7DDF7F7DDF01BC7EE79FB1EF014CB2F3CCB2";
    attribute INIT_39 of inst : label is "7BD301CCB2D34CB2F301BD36E79DB4EF017EBAF7DEBADF016E7BD34EF9DB014C";
    attribute INIT_3A of inst : label is "1FBCCF3F3EC701CCB2D34CB2F301EC73F3CCF1FB01DDF7F7DDF7F7014EF9DB6E";
    attribute INIT_3B of inst : label is "5D7FC00D3E7EC71FB9CF014CB2F3CCB2D301CCF1FBEC73F301DEBADF7EBAF701";
    attribute INIT_3C of inst : label is "D7FFF5C00D0EF9C30E7BC300357FD7FFF5FF5C00D0CF1C30C73C30037F5D7FFF";
    attribute INIT_3D of inst : label is "77DFDF77C00D0E7BC30EF9C30037F5FF5D7FD7FC00D0C73C30CF1C300357FFF5";
    attribute INIT_3E of inst : label is "7DFDF77DFDC00D0CF1C30C73C3003777F77DFDDFDC00D0EF9C30E7BC30035FDF";
    attribute INIT_3F of inst : label is "00000000000000010C73C30CF1C30035FDDFDF77F77C00D0E7BC30EF9C300377";
  begin
  inst : RAMB16_S2
      --pragma translate_off
      generic map (
        INIT_00 => romgen_str2bv(inst'INIT_00),
        INIT_01 => romgen_str2bv(inst'INIT_01),
        INIT_02 => romgen_str2bv(inst'INIT_02),
        INIT_03 => romgen_str2bv(inst'INIT_03),
        INIT_04 => romgen_str2bv(inst'INIT_04),
        INIT_05 => romgen_str2bv(inst'INIT_05),
        INIT_06 => romgen_str2bv(inst'INIT_06),
        INIT_07 => romgen_str2bv(inst'INIT_07),
        INIT_08 => romgen_str2bv(inst'INIT_08),
        INIT_09 => romgen_str2bv(inst'INIT_09),
        INIT_0A => romgen_str2bv(inst'INIT_0A),
        INIT_0B => romgen_str2bv(inst'INIT_0B),
        INIT_0C => romgen_str2bv(inst'INIT_0C),
        INIT_0D => romgen_str2bv(inst'INIT_0D),
        INIT_0E => romgen_str2bv(inst'INIT_0E),
        INIT_0F => romgen_str2bv(inst'INIT_0F),
        INIT_10 => romgen_str2bv(inst'INIT_10),
        INIT_11 => romgen_str2bv(inst'INIT_11),
        INIT_12 => romgen_str2bv(inst'INIT_12),
        INIT_13 => romgen_str2bv(inst'INIT_13),
        INIT_14 => romgen_str2bv(inst'INIT_14),
        INIT_15 => romgen_str2bv(inst'INIT_15),
        INIT_16 => romgen_str2bv(inst'INIT_16),
        INIT_17 => romgen_str2bv(inst'INIT_17),
        INIT_18 => romgen_str2bv(inst'INIT_18),
        INIT_19 => romgen_str2bv(inst'INIT_19),
        INIT_1A => romgen_str2bv(inst'INIT_1A),
        INIT_1B => romgen_str2bv(inst'INIT_1B),
        INIT_1C => romgen_str2bv(inst'INIT_1C),
        INIT_1D => romgen_str2bv(inst'INIT_1D),
        INIT_1E => romgen_str2bv(inst'INIT_1E),
        INIT_1F => romgen_str2bv(inst'INIT_1F),
        INIT_20 => romgen_str2bv(inst'INIT_20),
        INIT_21 => romgen_str2bv(inst'INIT_21),
        INIT_22 => romgen_str2bv(inst'INIT_22),
        INIT_23 => romgen_str2bv(inst'INIT_23),
        INIT_24 => romgen_str2bv(inst'INIT_24),
        INIT_25 => romgen_str2bv(inst'INIT_25),
        INIT_26 => romgen_str2bv(inst'INIT_26),
        INIT_27 => romgen_str2bv(inst'INIT_27),
        INIT_28 => romgen_str2bv(inst'INIT_28),
        INIT_29 => romgen_str2bv(inst'INIT_29),
        INIT_2A => romgen_str2bv(inst'INIT_2A),
        INIT_2B => romgen_str2bv(inst'INIT_2B),
        INIT_2C => romgen_str2bv(inst'INIT_2C),
        INIT_2D => romgen_str2bv(inst'INIT_2D),
        INIT_2E => romgen_str2bv(inst'INIT_2E),
        INIT_2F => romgen_str2bv(inst'INIT_2F),
        INIT_30 => romgen_str2bv(inst'INIT_30),
        INIT_31 => romgen_str2bv(inst'INIT_31),
        INIT_32 => romgen_str2bv(inst'INIT_32),
        INIT_33 => romgen_str2bv(inst'INIT_33),
        INIT_34 => romgen_str2bv(inst'INIT_34),
        INIT_35 => romgen_str2bv(inst'INIT_35),
        INIT_36 => romgen_str2bv(inst'INIT_36),
        INIT_37 => romgen_str2bv(inst'INIT_37),
        INIT_38 => romgen_str2bv(inst'INIT_38),
        INIT_39 => romgen_str2bv(inst'INIT_39),
        INIT_3A => romgen_str2bv(inst'INIT_3A),
        INIT_3B => romgen_str2bv(inst'INIT_3B),
        INIT_3C => romgen_str2bv(inst'INIT_3C),
        INIT_3D => romgen_str2bv(inst'INIT_3D),
        INIT_3E => romgen_str2bv(inst'INIT_3E),
        INIT_3F => romgen_str2bv(inst'INIT_3F)
        )
      --pragma translate_on
      port map (
        DO   => DATA(1 downto 0),
        ADDR => rom_addr,
        CLK  => CLK,
        DI   => "00",
        EN   => '1',
        SSR  => '0',
        WE   => '0'
        );
  end generate;
  rom1 : if true generate
    attribute INIT_00 of inst : label is "D7F18525732F33C3AA7498FF4633E35265398D759BEDF0CF0CD07B1009C28111";
    attribute INIT_01 of inst : label is "4F7EE1558534E95A49A95DDA98EB5E5F484F753E595EF3C1653AD4A67329CD30";
    attribute INIT_02 of inst : label is "155FC64544646C16CAA246C515116C06CE335116D7F1852546C9D5116E1359DD";
    attribute INIT_03 of inst : label is "16D76D465431D1A92D1B92F76FFA8594E35FC61495FFF3E2057F18525678CCB5";
    attribute INIT_04 of inst : label is "9B9583456B9A734C35FC614958CF9E5A9926388D5FC61495B151359CC504DAA1";
    attribute INIT_05 of inst : label is "4F9657BCF1653AD4A64329B14EC56CE316CC76537DD75FC60915BDB6FBD18DD5";
    attribute INIT_06 of inst : label is "557CE1DD11645B3E695FC61495DD4F7ED3DD55614D355A77EA63ACD398E213DD";
    attribute INIT_07 of inst : label is "959E39A0D5BA96C5116C5AC4ACBACA1EAC6A97F182456F4B92449224B42CE7B3";
    attribute INIT_08 of inst : label is "5758455566896E7EB7F618815FC61495EE3B10D71DB06E35D653BFF8855FC614";
    attribute INIT_09 of inst : label is "FB7330C587E8B61C896577651425610851354902995A32EC5C7B11116D7F1824";
    attribute INIT_0A of inst : label is "6BD26D1211215F465565655D9DF8800FB4400B5FC60915B71795C91CCC5E7724";
    attribute INIT_0B of inst : label is "1DC01DC4F74C5557F185257764846D7596D655D7F182455FF38505C061DEBEF6";
    attribute INIT_0C of inst : label is "F74C5557F185257769C415D65B5096474EB36DFB7AC9A25BD64C3B16A2B745C0";
    attribute INIT_0D of inst : label is "64CC486E671AB2284A024090E9668475467DA6E1ADD1AC6AC9D51A45B355ADC4";
    attribute INIT_0E of inst : label is "C580E45B5FC60915EC4DB95C5A8B112DB160F3192CC7B7ECB70E31414843BD06";
    attribute INIT_0F of inst : label is "B9BAAAE47E0BD55EEAAB9BAAAE47C2BD55E7C45D3DD93330C1B275445B2305B6";
    attribute INIT_10 of inst : label is "DD35D1E558C585C429998DCC105916EDDB1E343B2CD47112915D450CDDDDEEAA";
    attribute INIT_11 of inst : label is "FC61495DDDC477445ED699987873835419E5FB2877ECA1FB9635495699DC1713";
    attribute INIT_12 of inst : label is "154A6663735FC61495B1DA541FD01D3526E439766AEE544621107B645B8D1AC5";
    attribute INIT_13 of inst : label is "B9AD1AC5FC61495DDDF745ED6999878631B1BB17D514C76E5C4F74D747156316";
    attribute INIT_14 of inst : label is "35B5FC614958CA6511985B36B5E256CD0DF0DD5F576D46B1DFB0C4444F54DD65";
    attribute INIT_15 of inst : label is "6659A3EDA96630CCBCCF8D7F1852543DDF6735B5FC61495DDDFF6735BDDDDF67";
    attribute INIT_16 of inst : label is "697DD135D316B5FC61495DDDDF677469D6817A8C5C4D76BDD316B5FC614958CA";
    attribute INIT_17 of inst : label is "A6AAA68AA69F744D74C5AD7F185257777A7F67747BC555B117732C44B158F7B3";
    attribute INIT_18 of inst : label is "E17135DDD31391AE8CF9E57F18525630F77E9DD1EDB2D916D91A461AAAA5164A";
    attribute INIT_19 of inst : label is "17F18525777327475DD1517135DDD313D1AEF6005FC61495DDCC9D1E57745472";
    attribute INIT_1A of inst : label is "AA59DE84677A115679E897A2DE69E897A2DA579A68D44EFD802F53046FEB9D80";
    attribute INIT_1B of inst : label is "59BEFBDDAEFDA4F2CB27B8C9EF3B193586964B1E6993EC4627BAC3ADAAD5916B";
    attribute INIT_1C of inst : label is "AEC927030A249B0CBB1B439EE475295C6B17F635D663FF618CF8D499A45FD8D7";
    attribute INIT_1D of inst : label is "4998FF3BE79EFB2689822092C4882F48AD54EF53AE8912A09D2A9608BEB9264C";
    attribute INIT_1E of inst : label is "56DC1D5747EF355B9BEEECDCDFD4333FB0E2E35D661121319191238EBBEB038D";
    attribute INIT_1F of inst : label is "69247597F185257755498EDAA30E39F6A8C38E31C58ED6398EB6F6BAC57F1824";
    attribute INIT_20 of inst : label is "34D6337A52D6CA973E9721A491D65FC61495DD552634D6337A52D6CA973385C8";
    attribute INIT_21 of inst : label is "D56199B2DBDD7D1651B173CC7F6CB6CCCFB2EEFA76447B8E6B36EE6D2AF6A683";
    attribute INIT_22 of inst : label is "B7542510007B575713BDD531155DC35D514354CDE2D4014B94915FC61495DD1D";
    attribute INIT_23 of inst : label is "6C44046865507B0C69301130321932DBED7CCEB3A56E95F015D2D0815815B76D";
    attribute INIT_24 of inst : label is "7AC775C77867730F7448746C38CB07D5B78E77399C11133121AA4660420E0C8D";
    attribute INIT_25 of inst : label is "001E4A1C40207D2003030CDC007080C1070CECB30088F7475117765CDDCE7547";
    attribute INIT_26 of inst : label is "930604E4F9546FB4ACC57454746DD36565AA54DDD1A519A2DE031494152747D0";
    attribute INIT_27 of inst : label is "1C00010000045016BC171C48000087647B2CAC712224D66DDDDD66DDDDBA000A";
    attribute INIT_28 of inst : label is "00000000000000000000000000C3B80880538709116000280003A48CBE40817C";
    attribute INIT_29 of inst : label is "0000000000000000000000000000000000000000000000000000000000000000";
    attribute INIT_2A of inst : label is "2FC88A08705800882FC88A0839A7FBE846C30C859637BE0C2434CC1000000000";
    attribute INIT_2B of inst : label is "6666666666666666777777777777777743773323331FC6E75F3ACF0C80580088";
    attribute INIT_2C of inst : label is "DEFCDEFCDEFCDEFCDEB89AB89AB89AB89AB89AB89AB89AB89AB89AB456745674";
    attribute INIT_2D of inst : label is "FC3CCC0C8FBEFFDFFDF823EFB7D77D7E0CCCDDDDDDDDEEEEEEEEFFFFFFFFCCCC";
    attribute INIT_2E of inst : label is "0C0CCFC33F30CC0CBF47EBECF3CC0C5FCEF30D3ACC0C7C8AEBFF77CC0C0FC0C3";
    attribute INIT_2F of inst : label is "DB3CBECC0CCC03F33FF0CC0C7E82CBFD7ACC0C9E8FDBAD7CCC0C3DC9FB9F3ACC";
    attribute INIT_30 of inst : label is "CC0CCF07DF6DF6CC0CFF00F3FCFCCC0C4CC8DB1F72CC0CAD01C3EFF6CC0C8F45";
    attribute INIT_31 of inst : label is "CAF38F36CC0CFF8AEBFC73CC0C0CCCC33C30CC0CCD4DCF3EB6CC0C6D40EB4EB0";
    attribute INIT_32 of inst : label is "7ACC0C9C87EB6F7CCC0C7EC1CBDD3ACC0CCCCFC33F30CC0CFD4FEBAEFFCC0C5C";
    attribute INIT_33 of inst : label is "0EC4DB5D76CC0CAF09C36CFACC0C4C49DB3FB2CC0CCC03F33CF0CC0CBE8EDBFE";
    attribute INIT_34 of inst : label is "DE38F7204E41FF3EB6CC0C6F4CDBCCB0CC0C8D0FCF2EF6CC0C3F00C3FCFCCC0C";
    attribute INIT_35 of inst : label is "207C3FE38FF0DF209DB0CF3C36E7207C3DFFFF70DF20CCB1CF3C72F320DE38F7";
    attribute INIT_36 of inst : label is "F3CFBDCF202DF7CB2DF7CB200EBDEFBF7AC3205CBFF7DFF2D7208EF1FBEC7BE3";
    attribute INIT_37 of inst : label is "EF207D3EC71FB4DF208FF0DF7C3FE3206E7FF3CFF9DB209CF6C71DB3E7203F7E";
    attribute INIT_38 of inst : label is "31DF7C7CFF208FB9CF3E7EE3201D34C71D34C720FE72D34CB9FF20BC74CF3D31";
    attribute INIT_39 of inst : label is "72C320DFB3D75CFEF7200CF5EBAD73C320BF33D34CFCEF20DCB8EFBE32F720FF";
    attribute INIT_3A of inst : label is "6F77E38DFDDB201DF2E79CB7C7207D7AF3CEB5DF20EEFBFBEEFBFB200CB1FFFC";
    attribute INIT_3B of inst : label is "CD3EC40C3F7ED34FBDCF203D74EFBC35CF20FC3ED75FB0FF204CFCEFBF33D320";
    attribute INIT_3C of inst : label is "CF3EF3C40CBC39F7FE70E710307FC3CFB0FF3C40CDCBFEF9FF2FF103334F3CFB";
    attribute INIT_3D of inst : label is "30CB8C32C40CBFF6D77DBFE7103330FF1CFFC3EC40C5C74EF9D31DF10307BCF1";
    attribute INIT_3E of inst : label is "FDFDFF7FFFC40CBF31F7FC7CE7103373F30CBCCFFC40CDEB3EF9CFAFF103030E";
    attribute INIT_3F of inst : label is "0000000000000000BDF2D77CB7E710303CCFDFF3F32C40C5D7CEF9F35DF10337";
  begin
  inst : RAMB16_S2
      --pragma translate_off
      generic map (
        INIT_00 => romgen_str2bv(inst'INIT_00),
        INIT_01 => romgen_str2bv(inst'INIT_01),
        INIT_02 => romgen_str2bv(inst'INIT_02),
        INIT_03 => romgen_str2bv(inst'INIT_03),
        INIT_04 => romgen_str2bv(inst'INIT_04),
        INIT_05 => romgen_str2bv(inst'INIT_05),
        INIT_06 => romgen_str2bv(inst'INIT_06),
        INIT_07 => romgen_str2bv(inst'INIT_07),
        INIT_08 => romgen_str2bv(inst'INIT_08),
        INIT_09 => romgen_str2bv(inst'INIT_09),
        INIT_0A => romgen_str2bv(inst'INIT_0A),
        INIT_0B => romgen_str2bv(inst'INIT_0B),
        INIT_0C => romgen_str2bv(inst'INIT_0C),
        INIT_0D => romgen_str2bv(inst'INIT_0D),
        INIT_0E => romgen_str2bv(inst'INIT_0E),
        INIT_0F => romgen_str2bv(inst'INIT_0F),
        INIT_10 => romgen_str2bv(inst'INIT_10),
        INIT_11 => romgen_str2bv(inst'INIT_11),
        INIT_12 => romgen_str2bv(inst'INIT_12),
        INIT_13 => romgen_str2bv(inst'INIT_13),
        INIT_14 => romgen_str2bv(inst'INIT_14),
        INIT_15 => romgen_str2bv(inst'INIT_15),
        INIT_16 => romgen_str2bv(inst'INIT_16),
        INIT_17 => romgen_str2bv(inst'INIT_17),
        INIT_18 => romgen_str2bv(inst'INIT_18),
        INIT_19 => romgen_str2bv(inst'INIT_19),
        INIT_1A => romgen_str2bv(inst'INIT_1A),
        INIT_1B => romgen_str2bv(inst'INIT_1B),
        INIT_1C => romgen_str2bv(inst'INIT_1C),
        INIT_1D => romgen_str2bv(inst'INIT_1D),
        INIT_1E => romgen_str2bv(inst'INIT_1E),
        INIT_1F => romgen_str2bv(inst'INIT_1F),
        INIT_20 => romgen_str2bv(inst'INIT_20),
        INIT_21 => romgen_str2bv(inst'INIT_21),
        INIT_22 => romgen_str2bv(inst'INIT_22),
        INIT_23 => romgen_str2bv(inst'INIT_23),
        INIT_24 => romgen_str2bv(inst'INIT_24),
        INIT_25 => romgen_str2bv(inst'INIT_25),
        INIT_26 => romgen_str2bv(inst'INIT_26),
        INIT_27 => romgen_str2bv(inst'INIT_27),
        INIT_28 => romgen_str2bv(inst'INIT_28),
        INIT_29 => romgen_str2bv(inst'INIT_29),
        INIT_2A => romgen_str2bv(inst'INIT_2A),
        INIT_2B => romgen_str2bv(inst'INIT_2B),
        INIT_2C => romgen_str2bv(inst'INIT_2C),
        INIT_2D => romgen_str2bv(inst'INIT_2D),
        INIT_2E => romgen_str2bv(inst'INIT_2E),
        INIT_2F => romgen_str2bv(inst'INIT_2F),
        INIT_30 => romgen_str2bv(inst'INIT_30),
        INIT_31 => romgen_str2bv(inst'INIT_31),
        INIT_32 => romgen_str2bv(inst'INIT_32),
        INIT_33 => romgen_str2bv(inst'INIT_33),
        INIT_34 => romgen_str2bv(inst'INIT_34),
        INIT_35 => romgen_str2bv(inst'INIT_35),
        INIT_36 => romgen_str2bv(inst'INIT_36),
        INIT_37 => romgen_str2bv(inst'INIT_37),
        INIT_38 => romgen_str2bv(inst'INIT_38),
        INIT_39 => romgen_str2bv(inst'INIT_39),
        INIT_3A => romgen_str2bv(inst'INIT_3A),
        INIT_3B => romgen_str2bv(inst'INIT_3B),
        INIT_3C => romgen_str2bv(inst'INIT_3C),
        INIT_3D => romgen_str2bv(inst'INIT_3D),
        INIT_3E => romgen_str2bv(inst'INIT_3E),
        INIT_3F => romgen_str2bv(inst'INIT_3F)
        )
      --pragma translate_on
      port map (
        DO   => DATA(3 downto 2),
        ADDR => rom_addr,
        CLK  => CLK,
        DI   => "00",
        EN   => '1',
        SSR  => '0',
        WE   => '0'
        );
  end generate;
  rom2 : if true generate
    attribute INIT_00 of inst : label is "0E3212CCF7037B37A4E93BE441F01F000FFC7C3031CC35D30116008F1F8FF80A";
    attribute INIT_01 of inst : label is "FC0C08FAA9FDD334C813012931D0E0D3090C43F0530C371A4C34C93CF2530F75";
    attribute INIT_02 of inst : label is "027C88080838834433ACF83E222480B8322222480E3212CCF83A222483242310";
    attribute INIT_03 of inst : label is "28070296B57E05E2425100DF4280023BFF38C84B334E38E850E3212CCF3BCB32";
    attribute INIT_04 of inst : label is "510E0D8800ACF3DD438C84B331FC84E93A4EFA1C38C84B331454421A31212026";
    attribute INIT_05 of inst : label is "FC14C30DCA4F3CC93CE25314CC53832248054221C3E438C872D3CE3CCCE52DC2";
    attribute INIT_06 of inst : label is "22250262A20D2014D338C84B3310FC0C33103EAA7F7304E464C743E439E27310";
    attribute INIT_07 of inst : label is "330EFE0C810CF8362481833A7C0813E4C5310E321CB4C3310CC330CC370C8BF1";
    attribute INIT_08 of inst : label is "4E9382797B57442F3C394A1038C84B330CF141CF8E338DF0C0EFCE3A1438C84B";
    attribute INIT_09 of inst : label is "59999034354914A5925A494A5A69525572454032255E8C89EF3B262080E321CB";
    attribute INIT_0A of inst : label is "4B2461D4D5007C43504242520159999559999538C872D3997B69082665EC9420";
    attribute INIT_0B of inst : label is "888888040400488E3212CCC408988070340357CE321CB4C304D414B17540D115";
    attribute INIT_0C of inst : label is "0400488E3212CCC4038921C0D00220C808320C9324F30CD3A4CB70E0CC384088";
    attribute INIT_0D of inst : label is "48B343440360CC8320D2208A43000A8A88320C020E100F83322220D201220C04";
    attribute INIT_0E of inst : label is "0B04848338C872D3C49D104C8331430C02C1C2210C9FF2FC0290C20230B40CDC";
    attribute INIT_0F of inst : label is "51A11144F141107C84451211144F141107C6A88B4A24A2231E2CA8A920424830";
    attribute INIT_10 of inst : label is "1001C1222BCA32494F3202932483483101422222484DB7C812060A8AA8A8A844";
    attribute INIT_11 of inst : label is "8C84B33103C8B8408800E3202084E220220C8322220C8883A0C893ECF3EC2010";
    attribute INIT_12 of inst : label is "CB93CC80A438C84B3314102020147C949443888B9320C8092524830D20CE4333";
    attribute INIT_13 of inst : label is "10DE43338C84B33103F840800E3202094214227B122D1844004040070488AF28";
    attribute INIT_14 of inst : label is "73338C84B33BD0CC273D80CA08A3A0328228C27C9F805132C2B9C202226126DD";
    attribute INIT_15 of inst : label is "CEB3E70332CEF6DC0DECBCE3212CCF73D8CF73338C84B33103D8CF733103E8CF";
    attribute INIT_16 of inst : label is "83010101C013338C84B33103E8CF84033B348890004070310013338C84B33BD0";
    attribute INIT_17 of inst : label is "3CDB3CEB3CC040407004CCE3212CCC40F0D8CF843332233202220C8832290B36";
    attribute INIT_18 of inst : label is "020101C1001222031FC84CE3212CCEFDCF603E10CE04F38CF38CD1B3CF3A08DB";
    attribute INIT_19 of inst : label is "CE3212CCC4378C341E10020101C10012E203A41338C84B3310DE305087840082";
    attribute INIT_1A of inst : label is "34D3C00A0B002864D300880224D300880224FB3CFCAA886904C448588400F904";
    attribute INIT_1B of inst : label is "031CC310CD01CCCCF3CE3033CF014F7E4808006CF3F74C808FF4004DB3623A4D";
    attribute INIT_1C of inst : label is "38F3CC8273CF30DE314D8030EA04A324A304C1F0C0DFC3987C07C0038C1307C3";
    attribute INIT_1D of inst : label is "0037F0638E38E3CD332CD33CCB32CCB32110559238F32CCB32CC980058E3CC3B";
    attribute INIT_1E of inst : label is "4C456C571FC340510F11266665540CC5503CDF0C0F1001010141008F3420777C";
    attribute INIT_1F of inst : label is "938C2A8E3212CCC40C13BFA0EF7E79283BDF9F4A0A00F803FC38FB3C50E321CB";
    attribute INIT_20 of inst : label is "2CCFB720AC04A96B74D52A4E30AA38C84B3310304EF0CFB720AC04A96B75354A";
    attribute INIT_21 of inst : label is "02A30C30C03E450CD8D4D3054D82B8E220F027CCF38880D39020043A8C398C17";
    attribute INIT_22 of inst : label is "384080A1803B8F3010010301221C201C316212DC8C05A0802A3038C84B331031";
    attribute INIT_23 of inst : label is "F040043884886300630511040011011C8FFDCA32F883E206738CC2033F03F87E";
    attribute INIT_24 of inst : label is "646A643A677A414343434B6409207F65FF7C4401460110000158C7940908F53A";
    attribute INIT_25 of inst : label is "1828AAA98040A6A0514005C0240410034045C017001F265A2CC50A5A8A88A4B6";
    attribute INIT_26 of inst : label is "030060F0FDB4E2F3093450E4A779927112922D0A8C02A98028D02020AEAA6AE8";
    attribute INIT_27 of inst : label is "4158030051102000004480203AAA800200BCABF060401445555144DDDD362025";
    attribute INIT_28 of inst : label is "00000000000000000000000005180084C100202450482AFFA844042000584800";
    attribute INIT_29 of inst : label is "0000000000000000000000000000000000000000000000000000000000000000";
    attribute INIT_2A of inst : label is "7FE0CB30F00069007FE0CB30B8D0C5FD36F267774D48DBDB2B2AF33000000000";
    attribute INIT_2B of inst : label is "5555555555555555777777777777777740000010003C8BFBAE3FC70C00006900";
    attribute INIT_2C of inst : label is "5754646575764647575464657576464757546465757646475754646575764647";
    attribute INIT_2D of inst : label is "8FB5C80C4E7ED3FE3FC813DEB4CF8CF204664466446644664466446644665577";
    attribute INIT_2E of inst : label is "0CAD82EF5E71C80CDD8BCB1E74C80C5F48FB5CB8C80CCE49F74DB0C80C8C46C7";
    attribute INIT_2F of inst : label is "CBAE7FC80C4F8DFF6C7BC80C8C45FFEFB2C80C5E0DDFADFEC80C1DCAFF6E3DC8";
    attribute INIT_30 of inst : label is "C80CEE05C39DF2C80C5E4DD79DBFC80C2E44F7EDBFC80CAC87CBAF77C80C3D86";
    attribute INIT_31 of inst : label is "44FB9FB4C80C4E4DC7CDBCC80C8D42E74FB1C80C7F8AD30C7DC80CADC2E35E32";
    attribute INIT_32 of inst : label is "BEC80C9D01EF6EFEC80C1DCADF2E31C80C6F8ACF5C79C80CDD8BFB5E7CC80C9C";
    attribute INIT_33 of inst : label is "2E44C7ADB3C80C6F8BCB6C7BC80CBD82FB2E77C80C4F8DDFED73C80C0D45CF6E";
    attribute INIT_34 of inst : label is "9E7DE710FE8AF38D71C80C6ECED39D32C80CEE05F3DDFEC80C9C45C79FB7C80C";
    attribute INIT_35 of inst : label is "10AEFCF3DF3BEF102FFDDF4F7FCF10DC35EF8D70FB109C31DF4C70EB108F79E3";
    attribute INIT_36 of inst : label is "EF8FBFDB106CB6DB7DB2DF103DBBF7EEF6C310BFBFE7AFFEE3103CB0E39C32C3";
    attribute INIT_37 of inst : label is "D310FF7FDB7FFDF3104D33CB3CF4D710CC32EF8CB0F7101CFADF4EB3CB105FFE";
    attribute INIT_38 of inst : label is "3DEF8F7CEB10DE35CF0D78FB104D71D35C75D710FE74C72D39F3107D70D76C35";
    attribute INIT_39 of inst : label is "F2D310BDB3F7ECF6E3107FBCC31F3ED310EFF8E39E3FFF10ACF1CF0C73EF109F";
    attribute INIT_3A of inst : label is "4F3EFFCFBCD7105CF6DF4DB3DB101DFAFFCEB7CB10AEBEEBBFBAEF107CB3E7AC";
    attribute INIT_3B of inst : label is "2DBFC80CFF7CD76F3DF3107E70C72C39D310BD73FBFCF5E3100C37DB7DF0C710";
    attribute INIT_3C of inst : label is "E7FEF1C80C4DB6FFCD34DB20323AFFEFFDE39C80CFFFBE7BE7DF32033B4C36DF";
    attribute INIT_3D of inst : label is "32CFAFBBC80C9EFBCF0E79EF2031B7CB0C70D77C80C3DB6D36D34C3203039F78";
    attribute INIT_3E of inst : label is "1D7CF77CF5C80C8EBEFFCF38EB20333EEFAEF9F3DC80CFDF7D77D75F32032BCE";
    attribute INIT_3F of inst : label is "00000000000000005DF7CF0D75DF2030B3DB4D74C73C80C3EBAE3AE38C320313";
  begin
  inst : RAMB16_S2
      --pragma translate_off
      generic map (
        INIT_00 => romgen_str2bv(inst'INIT_00),
        INIT_01 => romgen_str2bv(inst'INIT_01),
        INIT_02 => romgen_str2bv(inst'INIT_02),
        INIT_03 => romgen_str2bv(inst'INIT_03),
        INIT_04 => romgen_str2bv(inst'INIT_04),
        INIT_05 => romgen_str2bv(inst'INIT_05),
        INIT_06 => romgen_str2bv(inst'INIT_06),
        INIT_07 => romgen_str2bv(inst'INIT_07),
        INIT_08 => romgen_str2bv(inst'INIT_08),
        INIT_09 => romgen_str2bv(inst'INIT_09),
        INIT_0A => romgen_str2bv(inst'INIT_0A),
        INIT_0B => romgen_str2bv(inst'INIT_0B),
        INIT_0C => romgen_str2bv(inst'INIT_0C),
        INIT_0D => romgen_str2bv(inst'INIT_0D),
        INIT_0E => romgen_str2bv(inst'INIT_0E),
        INIT_0F => romgen_str2bv(inst'INIT_0F),
        INIT_10 => romgen_str2bv(inst'INIT_10),
        INIT_11 => romgen_str2bv(inst'INIT_11),
        INIT_12 => romgen_str2bv(inst'INIT_12),
        INIT_13 => romgen_str2bv(inst'INIT_13),
        INIT_14 => romgen_str2bv(inst'INIT_14),
        INIT_15 => romgen_str2bv(inst'INIT_15),
        INIT_16 => romgen_str2bv(inst'INIT_16),
        INIT_17 => romgen_str2bv(inst'INIT_17),
        INIT_18 => romgen_str2bv(inst'INIT_18),
        INIT_19 => romgen_str2bv(inst'INIT_19),
        INIT_1A => romgen_str2bv(inst'INIT_1A),
        INIT_1B => romgen_str2bv(inst'INIT_1B),
        INIT_1C => romgen_str2bv(inst'INIT_1C),
        INIT_1D => romgen_str2bv(inst'INIT_1D),
        INIT_1E => romgen_str2bv(inst'INIT_1E),
        INIT_1F => romgen_str2bv(inst'INIT_1F),
        INIT_20 => romgen_str2bv(inst'INIT_20),
        INIT_21 => romgen_str2bv(inst'INIT_21),
        INIT_22 => romgen_str2bv(inst'INIT_22),
        INIT_23 => romgen_str2bv(inst'INIT_23),
        INIT_24 => romgen_str2bv(inst'INIT_24),
        INIT_25 => romgen_str2bv(inst'INIT_25),
        INIT_26 => romgen_str2bv(inst'INIT_26),
        INIT_27 => romgen_str2bv(inst'INIT_27),
        INIT_28 => romgen_str2bv(inst'INIT_28),
        INIT_29 => romgen_str2bv(inst'INIT_29),
        INIT_2A => romgen_str2bv(inst'INIT_2A),
        INIT_2B => romgen_str2bv(inst'INIT_2B),
        INIT_2C => romgen_str2bv(inst'INIT_2C),
        INIT_2D => romgen_str2bv(inst'INIT_2D),
        INIT_2E => romgen_str2bv(inst'INIT_2E),
        INIT_2F => romgen_str2bv(inst'INIT_2F),
        INIT_30 => romgen_str2bv(inst'INIT_30),
        INIT_31 => romgen_str2bv(inst'INIT_31),
        INIT_32 => romgen_str2bv(inst'INIT_32),
        INIT_33 => romgen_str2bv(inst'INIT_33),
        INIT_34 => romgen_str2bv(inst'INIT_34),
        INIT_35 => romgen_str2bv(inst'INIT_35),
        INIT_36 => romgen_str2bv(inst'INIT_36),
        INIT_37 => romgen_str2bv(inst'INIT_37),
        INIT_38 => romgen_str2bv(inst'INIT_38),
        INIT_39 => romgen_str2bv(inst'INIT_39),
        INIT_3A => romgen_str2bv(inst'INIT_3A),
        INIT_3B => romgen_str2bv(inst'INIT_3B),
        INIT_3C => romgen_str2bv(inst'INIT_3C),
        INIT_3D => romgen_str2bv(inst'INIT_3D),
        INIT_3E => romgen_str2bv(inst'INIT_3E),
        INIT_3F => romgen_str2bv(inst'INIT_3F)
        )
      --pragma translate_on
      port map (
        DO   => DATA(5 downto 4),
        ADDR => rom_addr,
        CLK  => CLK,
        DI   => "00",
        EN   => '1',
        SSR  => '0',
        WE   => '0'
        );
  end generate;
  rom3 : if true generate
    attribute INIT_00 of inst : label is "C020207822BC29C20B82EBB0CDE8DE277EEA78ADF33F28A2255455121DE00151";
    attribute INIT_01 of inst : label is "B83F80335FE0AF0B80EF2482E4AECBB1C084BAE36F2F8250BE1482EBB02E862C";
    attribute INIT_02 of inst : label is "A238488888B0D02FAD0BB1003032F9310111032F8020207831003032F9008E2E";
    attribute INIT_03 of inst : label is "6FFBA0282A20220080A8E48EFEE548EBBE008081E04824B0B8020207822B86D2";
    attribute INIT_04 of inst : label is "A8EC410CBE4BB18B3008081E08866BC2E0BAEC26008081E08EA280AC4E0E6800";
    attribute INIT_05 of inst : label is "B8DBCBE090BF1C82EB802E8EC63B10112FB920AE4BA30080E0600828880A4AE0";
    attribute INIT_06 of inst : label is "76AC964646B8BF0BEE008081E02EB83FB12E0CD7F8202BD20B92BBC2E070312E";
    attribute INIT_07 of inst : label is "E04AEC404BEB710032FA2D40FAEFED0B63A2002038180248EB8AEABBE0F953E0";
    attribute INIT_08 of inst : label is "8020088282AAA3B3F4F13C22008081E00AE8E4AE48E039E2B7EE8A2C26008081";
    attribute INIT_09 of inst : label is "BBBBB0E8AAC0A82C0A828282C2C0A008A02ACC3002B31198B88E7063FC020381";
    attribute INIT_0A of inst : label is "AE080AA2AA223AA8A280802022BBBBBBBBBBBB0080E060AA2E0A40AEA8B82902";
    attribute INIT_0B of inst : label is "DDDDDC0C0B809D802020780B9151809AEFC8A380203818128828A83ECA28222E";
    attribute INIT_0C of inst : label is "0B809D802020780BAEC0626BBF2C6F989FF7FDEF7BEE2BADCB94108B5030DDDD";
    attribute INIT_0D of inst : label is "9962AAA391CB402F0B9034082E2248080910BC120C37B72D00202BCFE076B40C";
    attribute INIT_0E of inst : label is "C1E3AB9F0080E0608C0A8E442D48E47DF0788EEA7C41EF7AEBC98022C4B30812";
    attribute INIT_0F of inst : label is "4B355528EB3BA238D554B355528EB3BA23A84CFF333333128C400C0CBE2009F7";
    attribute INIT_10 of inst : label is "2E0262776B80EA80BAE0378A01AE2FC2E8E110120C03E063B22048044CCCCD55";
    attribute INIT_11 of inst : label is "08081E02E381B099E92B8E02A5A2050260B9ED0777B41DED0F982E0BAE066030";
    attribute INIT_12 of inst : label is "A92EB80DE2008081E08EA20378A2B9EDAA3814182E6B909B0301ADB8BF1C2D40";
    attribute INIT_13 of inst : label is "8E0C2D4008081E02E3B09A92B8E02A5A278E662EBA7882A380C0B80989DDAE03";
    attribute INIT_14 of inst : label is "26F008081E0B89BA02E321189808C846260666398EFE89166530F037670E60AA";
    attribute INIT_15 of inst : label is "BB2E223ED0BAE08AF0A7B80202078023AEBC26F008081E02E39EBC26F2E38EBC";
    attribute INIT_16 of inst : label is "2E02E3026026F008081E02E38EBF0DEE72F6C18880C09AD2E026F008081E0B89";
    attribute INIT_17 of inst : label is "DB42DB42DB40B8C09809BC02020780B8EBDEBF0DEF4766F6A555F9ABE7B89EF4";
    attribute INIT_18 of inst : label is "26030262E02746FC8866BC02020782E08EBAFC37BFFB6E2B6E6B882DB6D02382";
    attribute INIT_19 of inst : label is "002020780B9238822C3756030262E02706FC8F84008081E02E48E2080B0DD590";
    attribute INIT_1A of inst : label is "EBAE25408095020BAE5401500BAE5401500BB2EB81EE96F3E12E8281AE3F23E1";
    attribute INIT_1B of inst : label is "DF33ED2EFD33FA775D7DF0DF3F38E31C68A8EE0BAE31B40939E383B42D04E0BA";
    attribute INIT_1C of inst : label is "D75E78201D79E008D8E20AEB608B1F041DB089E2B7DECF177A3789DF7EC2278A";
    attribute INIT_1D of inst : label is "9DF7B31D79E7DF789E0789E7C1F07C1F0555600DF7DE0781E07800D287DF7CD1";
    attribute INIT_1E of inst : label is "83B8FBED8EFD23A8E2222EEEEEE8388BB0C75E2B7C22030222220007F4FF0278";
    attribute INIT_1F of inst : label is "EE3883402020780B80AFB8CB6EBA20F2DBAE8B302033F08EBAD340D238020381";
    attribute INIT_20 of inst : label is "BC4212A5E78F1D7C2BD507B8E20D008081E02E02BEE84212A5E78F1D7C26F541";
    attribute INIT_21 of inst : label is "E0D021F7DFBA3A28B3B3B1F92AFBE08001EB8CFF9B2B8E8F3E9BA38C34313C12";
    attribute INIT_22 of inst : label is "70C8081819D9EE003002E0023A370026020B3C4A978F0EEE78E2008081E02E82";
    attribute INIT_23 of inst : label is "B8880AB38A808F0C8E002302B03208FE3DE0BCFF3388CE200032202004B030CC";
    attribute INIT_24 of inst : label is "AA02A902AA82974C8A8A82AE38CE0E461E788F32A8B230030353CB1281338180";
    attribute INIT_25 of inst : label is "80ED042D0203B410100080C2300800230080C00300422AB2011882B8DEDC2C2E";
    attribute INIT_26 of inst : label is "30000000031920EC54E989182A8AA6866AA064AEE09B3A87A8220202201A0B00";
    attribute INIT_27 of inst : label is "5560400000100000025515708003255455C5000550008FF840C8FF40C80C340F";
    attribute INIT_28 of inst : label is "000000000000000000000000255157E5C95545455560800003A55545556E5155";
    attribute INIT_29 of inst : label is "0000000000000000000000000000000000000000000000000000000000000000";
    attribute INIT_2A of inst : label is "BFC0E3700C001010BFC0E37000C0CCFCF3F33F300C0CCFCF3F33F30800000000";
    attribute INIT_2B of inst : label is "3333333333333333222222222222222220000000002EC2E30D3ACF0C4C001010";
    attribute INIT_2C of inst : label is "3222110033222110033322110033322110003322110003322111003322111003";
    attribute INIT_2D of inst : label is "DF32C00C0F7ED7AE72C003DFB5FB9DB033222211110000333322221111000033";
    attribute INIT_2E of inst : label is "0C0EC7FBDD3EC00CCEC7FBDD3EC00CCEC4EBDD3EC00C8FC4EBDC32C00C8CC4FB";
    attribute INIT_2F of inst : label is "DB1FFEC00C4F0BCB1CFEC00C4F0FCBDCFEC00C4E0FCBDDFAC00C4EC3FBDD3AC0";
    attribute INIT_30 of inst : label is "C00CBD0CCB1EF6C00CFD08CB1EF2C00C3D08CB1EF2C00C3D0BDB1EF2C00C7C0B";
    attribute INIT_31 of inst : label is "C4EBDF32C00C8CC0FBDF32C00C8DC0FB1E36C00CBCC0FB1F32C00CBDC0FB1E36";
    attribute INIT_32 of inst : label is "FAC00C0E07FBDDFAC00C0EC7FBDD3EC00CCEC7FBDD3EC00C8FC7EBDC3EC00C8C";
    attribute INIT_33 of inst : label is "7C08DB1FF2C00C7F0BDB1CFEC00C7F0FCB1CFEC00C4E0FCBDDFEC00C4E03CBDD";
    attribute INIT_34 of inst : label is "0FF3E300BDCCFB1E36C00CFDC8CB1E36C00CFD08CB1EF2C00C3D08DB1EF2C00C";
    attribute INIT_35 of inst : label is "00FC31EF8CF2F300FC31FBCCF2F300BD71FBCCF7E300BD71CB0CF7E300BC7DCF";
    attribute INIT_36 of inst : label is "FFDFBAD3007F30FFCCBED3007F30EF8CBED7003F30EF8CBEC7003C35EF8DF2C7";
    attribute INIT_37 of inst : label is "F300EF78DF4EBFF3003F7CDF4FBFC3003F7CCF1FBFC3007F3CCF1FBED3007E3C";
    attribute INIT_38 of inst : label is "7DCB0FF3E300BC7DDB4FF3E300FC7DDF4FF3F300AC7DDF4FF3E300EC7DDF4FF3";
    attribute INIT_39 of inst : label is "B2C700FC34EF8DB2F700FC31FFCCF2F700BC31FFCCF2E300BD31CB0CF6E300BC";
    attribute INIT_3A of inst : label is "7E7CFFDFBBD3007F30FFDCBED3007F30EF9CBED3003F30EF8CBEC3003C34EF8D";
    attribute INIT_3B of inst : label is "3CFBC00CEF79DF4EFFF3002F7DDF4FFFC3002F7CCF0FBFC3007F7CCF0FBFD300";
    attribute INIT_3C of inst : label is "F3EFB4C00C0C30EF8CF3C3003330C3BEF3CFCC00CBC30FFFCF3E30032F1C73CF";
    attribute INIT_3D of inst : label is "77DFFFFFC00CFF3CDF4FFFFF0030FCF34D3FFF3C00C7F3CC30FFFD300313CF3C";
    attribute INIT_3E of inst : label is "0C38E32CB0C00CCC30EF8CF3F3003230C3FFF3CF8C00CBC30CF3CF3E30033FDF";
    attribute INIT_3F of inst : label is "00000000000000003F3CDF4FFFCF0031FCF30C3FFF7C00C7F3CF3CFFFD300303";
  begin
  inst : RAMB16_S2
      --pragma translate_off
      generic map (
        INIT_00 => romgen_str2bv(inst'INIT_00),
        INIT_01 => romgen_str2bv(inst'INIT_01),
        INIT_02 => romgen_str2bv(inst'INIT_02),
        INIT_03 => romgen_str2bv(inst'INIT_03),
        INIT_04 => romgen_str2bv(inst'INIT_04),
        INIT_05 => romgen_str2bv(inst'INIT_05),
        INIT_06 => romgen_str2bv(inst'INIT_06),
        INIT_07 => romgen_str2bv(inst'INIT_07),
        INIT_08 => romgen_str2bv(inst'INIT_08),
        INIT_09 => romgen_str2bv(inst'INIT_09),
        INIT_0A => romgen_str2bv(inst'INIT_0A),
        INIT_0B => romgen_str2bv(inst'INIT_0B),
        INIT_0C => romgen_str2bv(inst'INIT_0C),
        INIT_0D => romgen_str2bv(inst'INIT_0D),
        INIT_0E => romgen_str2bv(inst'INIT_0E),
        INIT_0F => romgen_str2bv(inst'INIT_0F),
        INIT_10 => romgen_str2bv(inst'INIT_10),
        INIT_11 => romgen_str2bv(inst'INIT_11),
        INIT_12 => romgen_str2bv(inst'INIT_12),
        INIT_13 => romgen_str2bv(inst'INIT_13),
        INIT_14 => romgen_str2bv(inst'INIT_14),
        INIT_15 => romgen_str2bv(inst'INIT_15),
        INIT_16 => romgen_str2bv(inst'INIT_16),
        INIT_17 => romgen_str2bv(inst'INIT_17),
        INIT_18 => romgen_str2bv(inst'INIT_18),
        INIT_19 => romgen_str2bv(inst'INIT_19),
        INIT_1A => romgen_str2bv(inst'INIT_1A),
        INIT_1B => romgen_str2bv(inst'INIT_1B),
        INIT_1C => romgen_str2bv(inst'INIT_1C),
        INIT_1D => romgen_str2bv(inst'INIT_1D),
        INIT_1E => romgen_str2bv(inst'INIT_1E),
        INIT_1F => romgen_str2bv(inst'INIT_1F),
        INIT_20 => romgen_str2bv(inst'INIT_20),
        INIT_21 => romgen_str2bv(inst'INIT_21),
        INIT_22 => romgen_str2bv(inst'INIT_22),
        INIT_23 => romgen_str2bv(inst'INIT_23),
        INIT_24 => romgen_str2bv(inst'INIT_24),
        INIT_25 => romgen_str2bv(inst'INIT_25),
        INIT_26 => romgen_str2bv(inst'INIT_26),
        INIT_27 => romgen_str2bv(inst'INIT_27),
        INIT_28 => romgen_str2bv(inst'INIT_28),
        INIT_29 => romgen_str2bv(inst'INIT_29),
        INIT_2A => romgen_str2bv(inst'INIT_2A),
        INIT_2B => romgen_str2bv(inst'INIT_2B),
        INIT_2C => romgen_str2bv(inst'INIT_2C),
        INIT_2D => romgen_str2bv(inst'INIT_2D),
        INIT_2E => romgen_str2bv(inst'INIT_2E),
        INIT_2F => romgen_str2bv(inst'INIT_2F),
        INIT_30 => romgen_str2bv(inst'INIT_30),
        INIT_31 => romgen_str2bv(inst'INIT_31),
        INIT_32 => romgen_str2bv(inst'INIT_32),
        INIT_33 => romgen_str2bv(inst'INIT_33),
        INIT_34 => romgen_str2bv(inst'INIT_34),
        INIT_35 => romgen_str2bv(inst'INIT_35),
        INIT_36 => romgen_str2bv(inst'INIT_36),
        INIT_37 => romgen_str2bv(inst'INIT_37),
        INIT_38 => romgen_str2bv(inst'INIT_38),
        INIT_39 => romgen_str2bv(inst'INIT_39),
        INIT_3A => romgen_str2bv(inst'INIT_3A),
        INIT_3B => romgen_str2bv(inst'INIT_3B),
        INIT_3C => romgen_str2bv(inst'INIT_3C),
        INIT_3D => romgen_str2bv(inst'INIT_3D),
        INIT_3E => romgen_str2bv(inst'INIT_3E),
        INIT_3F => romgen_str2bv(inst'INIT_3F)
        )
      --pragma translate_on
      port map (
        DO   => DATA(7 downto 6),
        ADDR => rom_addr,
        CLK  => CLK,
        DI   => "00",
        EN   => '1',
        SSR  => '0',
        WE   => '0'
        );
  end generate;
end RTL;
